------------------------------------------------------------------------------
-- Pen Package Parser                                                       --
--                                                                          --
-- Part of SparForte                                                        --
------------------------------------------------------------------------------
--                                                                          --
--            Copyright (C) 2001-2011 Free Software Foundation              --
--                                                                          --
-- This is free software;  you can  redistribute it  and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion.  This is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License  distributed with this;  see file COPYING.  If not, write --
-- to  the Free Software Foundation,  59 Temple Place - Suite 330,  Boston, --
-- MA 02111-1307, USA.                                                      --
--                                                                          --
-- This is maintained at http://www.pegasoft.ca                             --
--                                                                          --
------------------------------------------------------------------------------

with ada.strings.unbounded, world;
use ada.strings.unbounded, world;

package parser_pen is

------------------------------------------------------------------------------
-- Numerics package identifiers
------------------------------------------------------------------------------

pen_rect_t          : identifier;
pen_coordinate_t    : identifier;
pen_rgbcomponent_t  : identifier;
pen_rect_left_t     : identifier;
pen_rect_top_t      : identifier;
pen_rect_right_t    : identifier;
pen_rect_bottom_t   : identifier;
pen_canvas_id_t     : identifier;

pen_pen_mode_t      : identifier;
pen_mode_invert_t   : identifier;
pen_mode_add_t      : identifier;
pen_mode_subtract_t : identifier;
pen_mode_average_t  : identifier;
pen_mode_copy_t     : identifier;
pen_mode_off_t      : identifier;

pen_pen_brush_t     : identifier;
pen_brush_undefined_t : identifier;
pen_brush_pencil_t  : identifier;
pen_brush_stretch_t : identifier;
pen_brush_tile_t    : identifier;
pen_brush_stamp_t   : identifier;
pen_brush_smear_t   : identifier;

pen_set_rect_t       : identifier;
pen_is_empty_rect_t  : identifier;
pen_offset_rect_t    : identifier;
pen_inset_rect_t     : identifier;
pen_intersect_rect_t : identifier;
pen_inside_rect_t    : identifier;
pen_in_rect_t        : identifier;

pen_set_pen_mode_t   : identifier;
pen_set_pen_ink_t    : identifier;
pen_set_pen_brush_t  : identifier;
pen_set_pen_pattern_t: identifier;
pen_get_pen_mode_t   : identifier;
pen_get_pen_ink_t    : identifier;
pen_get_pen_brush_t  : identifier;
-- pen_get_pen_pattern_t: identifier;

pen_move_to_t        : identifier;
pen_move_t           : identifier;
pen_line_to_t        : identifier;
pen_line_t           : identifier;
pen_hline_t          : identifier;
pen_vline_t          : identifier;

pen_frame_rect_t     : identifier;
pen_paint_rect_t     : identifier;
pen_fill_rect_t      : identifier;
pen_frame_ellipse_t  : identifier;
pen_paint_ellipse_t  : identifier;
pen_fill_ellipse_t   : identifier;
pen_clear_t          : identifier;

pen_new_screen_canvas_t : identifier;
pen_new_gl_screen_canvas_t : identifier;
pen_new_window_canvas_t : identifier;
pen_new_gl_window_canvas_t : identifier;
pen_new_canvas_t     : identifier;
pen_save_canvas_t    : identifier;
pen_set_title_t      : identifier;
pen_close_canvas_t   : identifier;

pen_wait_to_reveal_t : identifier;
pen_reveal_t         : identifier;
pen_reveal_now_t     : identifier;

pen_clip_rect_t      : identifier;

pen_greyscale_t      : identifier;
pen_blend_t          : identifier;
pen_fade_t           : identifier;

pen_plot_t           : identifier;

pen_set_font_t       : identifier;
pen_put_t            : identifier;

pen_pen_color_name_t : identifier;
color_name_aliceblue_t : identifier;
color_name_antiquewhite_t : identifier;
color_name_antiquewhite1_t : identifier;
color_name_antiquewhite2_t : identifier;
color_name_antiquewhite3_t : identifier;
color_name_antiquewhite4_t : identifier;
color_name_aquamarine_t : identifier;
color_name_aquamarine1_t : identifier;
color_name_aquamarine2_t : identifier;
color_name_aquamarine3_t : identifier;
color_name_aquamarine4_t : identifier;
color_name_azure_t : identifier;
color_name_azure1_t : identifier;
color_name_azure2_t : identifier;
color_name_azure3_t : identifier;
color_name_azure4_t : identifier;
color_name_beige_t : identifier;
color_name_bisque_t : identifier;
color_name_bisque1_t : identifier;
color_name_bisque2_t : identifier;
color_name_bisque3_t : identifier;
color_name_bisque4_t : identifier;
color_name_black_t : identifier;
color_name_blanchedalmond_t : identifier;
color_name_blue_t : identifier;
color_name_blue1_t : identifier;
color_name_blue2_t : identifier;
color_name_blue3_t : identifier;
color_name_blue4_t : identifier;
color_name_blueviolet_t : identifier;
color_name_brown_t : identifier;
color_name_brown1_t : identifier;
color_name_brown2_t : identifier;
color_name_brown3_t : identifier;
color_name_brown4_t : identifier;
color_name_burlywood_t : identifier;
color_name_burlywood1_t : identifier;
color_name_burlywood2_t : identifier;
color_name_burlywood3_t : identifier;
color_name_burlywood4_t : identifier;
color_name_cadetblue_t : identifier;
color_name_cadetblue1_t : identifier;
color_name_cadetblue2_t : identifier;
color_name_cadetblue3_t : identifier;
color_name_cadetblue4_t : identifier;
color_name_chartreuse_t : identifier;
color_name_chartreuse1_t : identifier;
color_name_chartreuse2_t : identifier;
color_name_chartreuse3_t : identifier;
color_name_chartreuse4_t : identifier;
color_name_chocolate_t : identifier;
color_name_chocolate1_t : identifier;
color_name_chocolate2_t : identifier;
color_name_chocolate3_t : identifier;
color_name_chocolate4_t : identifier;
color_name_coral_t : identifier;
color_name_coral1_t : identifier;
color_name_coral2_t : identifier;
color_name_coral3_t : identifier;
color_name_coral4_t : identifier;
color_name_cornflowerblue_t : identifier;
color_name_cornsilk_t : identifier;
color_name_cornsilk1_t : identifier;
color_name_cornsilk2_t : identifier;
color_name_cornsilk3_t : identifier;
color_name_cornsilk4_t : identifier;
color_name_cyan_t : identifier;
color_name_cyan1_t : identifier;
color_name_cyan2_t : identifier;
color_name_cyan3_t : identifier;
color_name_cyan4_t : identifier;
color_name_darkblue_t : identifier;
color_name_darkcyan_t : identifier;
color_name_darkgoldenrod_t : identifier;
color_name_darkgoldenrod1_t : identifier;
color_name_darkgoldenrod2_t : identifier;
color_name_darkgoldenrod3_t : identifier;
color_name_darkgoldenrod4_t : identifier;
color_name_darkgreen_t : identifier;
color_name_darkgrey_t : identifier;
color_name_darkkhaki_t : identifier;
color_name_darkmagenta_t : identifier;
color_name_darkolivegreen_t : identifier;
color_name_darkolivegreen1_t : identifier;
color_name_darkolivegreen2_t : identifier;
color_name_darkolivegreen3_t : identifier;
color_name_darkolivegreen4_t : identifier;
color_name_darkorange_t : identifier;
color_name_darkorange1_t : identifier;
color_name_darkorange2_t : identifier;
color_name_darkorange3_t : identifier;
color_name_darkorange4_t : identifier;
color_name_darkorchid_t : identifier;
color_name_darkorchid1_t : identifier;
color_name_darkorchid2_t : identifier;
color_name_darkorchid3_t : identifier;
color_name_darkorchid4_t : identifier;
color_name_darkred_t : identifier;
color_name_darksalmon_t : identifier;
color_name_darkseagreen_t : identifier;
color_name_darkseagreen1_t : identifier;
color_name_darkseagreen2_t : identifier;
color_name_darkseagreen3_t : identifier;
color_name_darkseagreen4_t : identifier;
color_name_darkslateblue_t : identifier;
color_name_darkslategrey_t : identifier;
color_name_darkslategrey1_t : identifier;
color_name_darkslategrey2_t : identifier;
color_name_darkslategrey3_t : identifier;
color_name_darkslategrey4_t : identifier;
color_name_darkturquoise_t : identifier;
color_name_darkviolet_t : identifier;
color_name_deeppink_t : identifier;
color_name_deeppink1_t : identifier;
color_name_deeppink2_t : identifier;
color_name_deeppink3_t : identifier;
color_name_deeppink4_t : identifier;
color_name_deepskyblue_t : identifier;
color_name_deepskyblue1_t : identifier;
color_name_deepskyblue2_t : identifier;
color_name_deepskyblue3_t : identifier;
color_name_deepskyblue4_t : identifier;
color_name_dimgrey_t : identifier;
color_name_dodgerblue_t : identifier;
color_name_dodgerblue1_t : identifier;
color_name_dodgerblue2_t : identifier;
color_name_dodgerblue3_t : identifier;
color_name_dodgerblue4_t : identifier;
color_name_firebrick_t : identifier;
color_name_firebrick1_t : identifier;
color_name_firebrick2_t : identifier;
color_name_firebrick3_t : identifier;
color_name_firebrick4_t : identifier;
color_name_floralwhite_t : identifier;
color_name_forestgreen_t : identifier;
color_name_gainsboro_t : identifier;
color_name_ghostwhite_t : identifier;
color_name_gold_t : identifier;
color_name_gold1_t : identifier;
color_name_gold2_t : identifier;
color_name_gold3_t : identifier;
color_name_gold4_t : identifier;
color_name_goldenrod_t : identifier;
color_name_goldenrod1_t : identifier;
color_name_goldenrod2_t : identifier;
color_name_goldenrod3_t : identifier;
color_name_goldenrod4_t : identifier;
color_name_green_t : identifier;
color_name_green1_t : identifier;
color_name_green2_t : identifier;
color_name_green3_t : identifier;
color_name_green4_t : identifier;
color_name_greenyellow_t : identifier;
color_name_grey_t : identifier;
color_name_honeydew_t : identifier;
color_name_honeydew1_t : identifier;
color_name_honeydew2_t : identifier;
color_name_honeydew3_t : identifier;
color_name_honeydew4_t : identifier;
color_name_hotpink_t : identifier;
color_name_hotpink1_t : identifier;
color_name_hotpink2_t : identifier;
color_name_hotpink3_t : identifier;
color_name_hotpink4_t : identifier;
color_name_indianred_t : identifier;
color_name_indianred1_t : identifier;
color_name_indianred2_t : identifier;
color_name_indianred3_t : identifier;
color_name_indianred4_t : identifier;
color_name_ivory_t : identifier;
color_name_ivory1_t : identifier;
color_name_ivory2_t : identifier;
color_name_ivory3_t : identifier;
color_name_ivory4_t : identifier;
color_name_khaki_t : identifier;
color_name_khaki1_t : identifier;
color_name_khaki2_t : identifier;
color_name_khaki3_t : identifier;
color_name_khaki4_t : identifier;
color_name_lavender_t : identifier;
color_name_lavenderblush_t : identifier;
color_name_lavenderblush1_t : identifier;
color_name_lavenderblush2_t : identifier;
color_name_lavenderblush3_t : identifier;
color_name_lavenderblush4_t : identifier;
color_name_lawngreen_t : identifier;
color_name_lemonchiffon_t : identifier;
color_name_lemonchiffon1_t : identifier;
color_name_lemonchiffon2_t : identifier;
color_name_lemonchiffon3_t : identifier;
color_name_lemonchiffon4_t : identifier;
color_name_lightblue_t : identifier;
color_name_lightblue1_t : identifier;
color_name_lightblue2_t : identifier;
color_name_lightblue3_t : identifier;
color_name_lightblue4_t : identifier;
color_name_lightcoral_t : identifier;
color_name_lightcyan_t : identifier;
color_name_lightcyan1_t : identifier;
color_name_lightcyan2_t : identifier;
color_name_lightcyan3_t : identifier;
color_name_lightcyan4_t : identifier;
color_name_lightgoldenrod_t : identifier;
color_name_lightgoldenrod1_t : identifier;
color_name_lightgoldenrod2_t : identifier;
color_name_lightgoldenrod3_t : identifier;
color_name_lightgoldenrod4_t : identifier;
color_name_lightgoldenrodyellow_t : identifier;
color_name_lightgreen_t : identifier;
color_name_lightgrey_t : identifier;
color_name_lightpink_t : identifier;
color_name_lightpink1_t : identifier;
color_name_lightpink2_t : identifier;
color_name_lightpink3_t : identifier;
color_name_lightpink4_t : identifier;
color_name_lightsalmon_t : identifier;
color_name_lightsalmon1_t : identifier;
color_name_lightsalmon2_t : identifier;
color_name_lightsalmon3_t : identifier;
color_name_lightsalmon4_t : identifier;
color_name_lightseagreen_t : identifier;
color_name_lightskyblue_t : identifier;
color_name_lightskyblue1_t : identifier;
color_name_lightskyblue2_t : identifier;
color_name_lightskyblue3_t : identifier;
color_name_lightskyblue4_t : identifier;
color_name_lightslateblue_t : identifier;
color_name_lightslategrey_t : identifier;
color_name_lightsteelblue_t : identifier;
color_name_lightsteelblue1_t : identifier;
color_name_lightsteelblue2_t : identifier;
color_name_lightsteelblue3_t : identifier;
color_name_lightsteelblue4_t : identifier;
color_name_lightyellow_t : identifier;
color_name_lightyellow1_t : identifier;
color_name_lightyellow2_t : identifier;
color_name_lightyellow3_t : identifier;
color_name_lightyellow4_t : identifier;
color_name_limegreen_t : identifier;
color_name_linen_t : identifier;
color_name_magenta_t : identifier;
color_name_magenta1_t : identifier;
color_name_magenta2_t : identifier;
color_name_magenta3_t : identifier;
color_name_magenta4_t : identifier;
color_name_maroon_t : identifier;
color_name_maroon1_t : identifier;
color_name_maroon2_t : identifier;
color_name_maroon3_t : identifier;
color_name_maroon4_t : identifier;
color_name_mediumaquamarine_t : identifier;
color_name_mediumblue_t : identifier;
color_name_mediumorchid_t : identifier;
color_name_mediumorchid1_t : identifier;
color_name_mediumorchid2_t : identifier;
color_name_mediumorchid3_t : identifier;
color_name_mediumorchid4_t : identifier;
color_name_mediumpurple_t : identifier;
color_name_mediumpurple1_t : identifier;
color_name_mediumpurple2_t : identifier;
color_name_mediumpurple3_t : identifier;
color_name_mediumpurple4_t : identifier;
color_name_mediumseagreen_t : identifier;
color_name_mediumslateblue_t : identifier;
color_name_mediumspringgreen_t : identifier;
color_name_mediumturquoise_t : identifier;
color_name_mediumvioletred_t : identifier;
color_name_midnightblue_t : identifier;
color_name_mintcream_t : identifier;
color_name_mistyrose_t : identifier;
color_name_mistyrose1_t : identifier;
color_name_mistyrose2_t : identifier;
color_name_mistyrose3_t : identifier;
color_name_mistyrose4_t : identifier;
color_name_moccasin_t : identifier;
color_name_navajowhite_t : identifier;
color_name_navajowhite1_t : identifier;
color_name_navajowhite2_t : identifier;
color_name_navajowhite3_t : identifier;
color_name_navajowhite4_t : identifier;
color_name_navyblue_t : identifier;
color_name_oldlace_t : identifier;
color_name_olivedrab_t : identifier;
color_name_olivedrab1_t : identifier;
color_name_olivedrab2_t : identifier;
color_name_olivedrab3_t : identifier;
color_name_olivedrab4_t : identifier;
color_name_orange_t : identifier;
color_name_orange1_t : identifier;
color_name_orange2_t : identifier;
color_name_orange3_t : identifier;
color_name_orange4_t : identifier;
color_name_orangered_t : identifier;
color_name_orangered1_t : identifier;
color_name_orangered2_t : identifier;
color_name_orangered3_t : identifier;
color_name_orangered4_t : identifier;
color_name_orchid_t : identifier;
color_name_orchid1_t : identifier;
color_name_orchid2_t : identifier;
color_name_orchid3_t : identifier;
color_name_orchid4_t : identifier;
color_name_palegoldenrod_t : identifier;
color_name_palegreen_t : identifier;
color_name_palegreen1_t : identifier;
color_name_palegreen2_t : identifier;
color_name_palegreen3_t : identifier;
color_name_palegreen4_t : identifier;
color_name_paleturquoise_t : identifier;
color_name_paleturquoise1_t : identifier;
color_name_paleturquoise2_t : identifier;
color_name_paleturquoise3_t : identifier;
color_name_paleturquoise4_t : identifier;
color_name_palevioletred_t : identifier;
color_name_palevioletred1_t : identifier;
color_name_palevioletred2_t : identifier;
color_name_palevioletred3_t : identifier;
color_name_palevioletred4_t : identifier;
color_name_papayawhip_t : identifier;
color_name_peachpuff_t : identifier;
color_name_peachpuff1_t : identifier;
color_name_peachpuff2_t : identifier;
color_name_peachpuff3_t : identifier;
color_name_peachpuff4_t : identifier;
color_name_peru_t : identifier;
color_name_pink_t : identifier;
color_name_pink1_t : identifier;
color_name_pink2_t : identifier;
color_name_pink3_t : identifier;
color_name_pink4_t : identifier;
color_name_plum_t : identifier;
color_name_plum1_t : identifier;
color_name_plum2_t : identifier;
color_name_plum3_t : identifier;
color_name_plum4_t : identifier;
color_name_powderblue_t : identifier;
color_name_purple_t : identifier;
color_name_purple1_t : identifier;
color_name_purple2_t : identifier;
color_name_purple3_t : identifier;
color_name_purple4_t : identifier;
color_name_red_t : identifier;
color_name_red1_t : identifier;
color_name_red2_t : identifier;
color_name_red3_t : identifier;
color_name_red4_t : identifier;
color_name_rosybrown_t : identifier;
color_name_rosybrown1_t : identifier;
color_name_rosybrown2_t : identifier;
color_name_rosybrown3_t : identifier;
color_name_rosybrown4_t : identifier;
color_name_royalblue_t : identifier;
color_name_royalblue1_t : identifier;
color_name_royalblue2_t : identifier;
color_name_royalblue3_t : identifier;
color_name_royalblue4_t : identifier;
color_name_saddlebrown_t : identifier;
color_name_salmon_t : identifier;
color_name_salmon1_t : identifier;
color_name_salmon2_t : identifier;
color_name_salmon3_t : identifier;
color_name_salmon4_t : identifier;
color_name_sandybrown_t : identifier;
color_name_seagreen_t : identifier;
color_name_seagreen1_t : identifier;
color_name_seagreen2_t : identifier;
color_name_seagreen3_t : identifier;
color_name_seagreen4_t : identifier;
color_name_seashell_t : identifier;
color_name_seashell1_t : identifier;
color_name_seashell2_t : identifier;
color_name_seashell3_t : identifier;
color_name_seashell4_t : identifier;
color_name_sienna_t : identifier;
color_name_sienna1_t : identifier;
color_name_sienna2_t : identifier;
color_name_sienna3_t : identifier;
color_name_sienna4_t : identifier;
color_name_skyblue_t : identifier;
color_name_skyblue1_t : identifier;
color_name_skyblue2_t : identifier;
color_name_skyblue3_t : identifier;
color_name_skyblue4_t : identifier;
color_name_slateblue_t : identifier;
color_name_slateblue1_t : identifier;
color_name_slateblue2_t : identifier;
color_name_slateblue3_t : identifier;
color_name_slateblue4_t : identifier;
color_name_slategray1_t : identifier;
color_name_slategray2_t : identifier;
color_name_slategray3_t : identifier;
color_name_slategray4_t : identifier;
color_name_slategrey_t : identifier;
color_name_snow_t : identifier;
color_name_snow1_t : identifier;
color_name_snow2_t : identifier;
color_name_snow3_t : identifier;
color_name_snow4_t : identifier;
color_name_springgreen_t : identifier;
color_name_springgreen1_t : identifier;
color_name_springgreen2_t : identifier;
color_name_springgreen3_t : identifier;
color_name_springgreen4_t : identifier;
color_name_steelblue_t : identifier;
color_name_steelblue1_t : identifier;
color_name_steelblue2_t : identifier;
color_name_steelblue3_t : identifier;
color_name_steelblue4_t : identifier;
color_name_tan_t : identifier;
color_name_tan1_t : identifier;
color_name_tan2_t : identifier;
color_name_tan3_t : identifier;
color_name_tan4_t : identifier;
color_name_thistle_t : identifier;
color_name_thistle1_t : identifier;
color_name_thistle2_t : identifier;
color_name_thistle3_t : identifier;
color_name_thistle4_t : identifier;
color_name_tomato_t : identifier;
color_name_tomato1_t : identifier;
color_name_tomato2_t : identifier;
color_name_tomato3_t : identifier;
color_name_tomato4_t : identifier;
color_name_turquoise_t : identifier;
color_name_turquoise1_t : identifier;
color_name_turquoise2_t : identifier;
color_name_turquoise3_t : identifier;
color_name_turquoise4_t : identifier;
color_name_violet_t : identifier;
color_name_violetred_t : identifier;
color_name_violetred1_t : identifier;
color_name_violetred2_t : identifier;
color_name_violetred3_t : identifier;
color_name_violetred4_t : identifier;
color_name_wheat_t : identifier;
color_name_wheat1_t : identifier;
color_name_wheat2_t : identifier;
color_name_wheat3_t : identifier;
color_name_wheat4_t : identifier;
color_name_white_t : identifier;
color_name_whitesmoke_t : identifier;
color_name_yellow_t : identifier;
color_name_yellow1_t : identifier;
color_name_yellow2_t : identifier;
color_name_yellow3_t : identifier;
color_name_yellow4_t : identifier;
color_name_yellowgreen_t : identifier;

pen_a_display_info_rec_t : identifier;
pen_a_display_info_rec_textbased_t : identifier;
pen_a_display_info_rec_h_res_t : identifier;
pen_a_display_info_rec_v_res_t : identifier;
pen_a_display_info_rec_c_res_t : identifier;
pen_a_display_info_rec_p_res_t : identifier;
pen_a_display_info_rec_d_res_t : identifier;

--- OpenGL Types

pen_glenum_t : identifier;
pen_glboolean_t : identifier;
pen_glbitfield_t : identifier;
pen_glbyte_t : identifier;
pen_glshort_t : identifier;
pen_glint_t : identifier;
pen_glubyte_t : identifier;
pen_glushort_t : identifier;
pen_gluint_t : identifier;
pen_glsizei_t : identifier;
pen_glfloat_t : identifier;
pen_glclampf_t : identifier;
pen_gldouble_t : identifier;
pen_glclampd_t : identifier;

-- C arrays

-- pen_gl_double_array_matrix_t : identifier;

-- OpenGL Constants

pen_gl_false_t : identifier;
pen_gl_true_t : identifier;
pen_gltypes_t : identifier;
pen_gl_byte_t : identifier;
pen_gl_unsigned_byte_t : identifier;
pen_gl_short_t : identifier;
pen_gl_unsigned_short_t : identifier;
pen_gl_int_t : identifier;
pen_gl_unsigned_int_t : identifier;
pen_gl_float_t : identifier;
pen_gl_2_bytes_t : identifier;
pen_gl_3_bytes_t : identifier;
pen_gl_4_bytes_t : identifier;
pen_gl_double_t : identifier;
pen_glprimitives_t : identifier;
pen_gl_points_t : identifier;
pen_gl_lines_t : identifier;
pen_gl_line_loop_t : identifier;
pen_gl_line_strip_t : identifier;
pen_gl_triangles_t : identifier;
pen_gl_triangle_strip_t : identifier;
pen_gl_triangle_fan_t : identifier;
pen_gl_quads_t : identifier;
pen_gl_quad_strip_t : identifier;
pen_gl_polygon_t : identifier;
pen_glvertexarrays_t : identifier;
pen_gl_vertex_array_t : identifier;
pen_gl_normal_array_t : identifier;
pen_gl_color_array_t : identifier;
pen_gl_index_array_t : identifier;
pen_gl_texture_coord_array_t : identifier;
pen_gl_edge_flag_array_t : identifier;
pen_gl_vertex_array_size_t : identifier;
pen_gl_vertex_array_type_t : identifier;
pen_gl_vertex_array_stride_t : identifier;
pen_gl_normal_array_type_t : identifier;
pen_gl_normal_array_stride_t : identifier;
pen_gl_color_array_size_t : identifier;
pen_gl_color_array_type_t : identifier;
pen_gl_color_array_stride_t : identifier;
pen_gl_index_array_type_t : identifier;
pen_gl_index_array_stride_t : identifier;
pen_gl_texture_coord_array_size_t : identifier;
pen_gl_texture_coord_array_type_t : identifier;
pen_gl_texture_coord_array_stride_t : identifier;
pen_gl_edge_flag_array_stride_t : identifier;
pen_gl_vertex_array_pointer_t : identifier;
pen_gl_normal_array_pointer_t : identifier;
pen_gl_color_array_pointer_t : identifier;
pen_gl_index_array_pointer_t : identifier;
pen_gl_texture_coord_array_pointer_t : identifier;
pen_gl_edge_flag_array_pointer_t : identifier;
pen_gl_v2f_t : identifier;
pen_gl_v3f_t : identifier;
pen_gl_c4ub_v2f_t : identifier;
pen_gl_c4ub_v3f_t : identifier;
pen_gl_c3f_v3f_t : identifier;
pen_gl_n3f_v3f_t : identifier;
pen_gl_c4f_n3f_v3f_t : identifier;
pen_gl_t2f_v3f_t : identifier;
pen_gl_t4f_v4f_t : identifier;
pen_gl_t2f_c4ub_v3f_t : identifier;
pen_gl_t2f_c3f_v3f_t : identifier;
pen_gl_t2f_n3f_v3f_t : identifier;
pen_gl_t2f_c4f_n3f_v3f_t : identifier;
pen_gl_t4f_c4f_n3f_v4f_t : identifier;
pen_glmodes_t : identifier;
pen_gl_matrix_mode_t : identifier;
pen_gl_modelview_t : identifier;
pen_gl_projection_t : identifier;
pen_gl_texture_t : identifier;
pen_glpoints_t : identifier;
pen_gl_point_smooth_t : identifier;
pen_gl_point_size_t : identifier;
pen_gl_point_size_granularity_t : identifier;
pen_gl_point_size_range_t : identifier;
pen_gllines_t : identifier;
pen_gl_line_smooth_t : identifier;
pen_gl_line_stipple_t : identifier;
pen_gl_line_stipple_pattern_t : identifier;
pen_gl_line_stipple_repeat_t : identifier;
pen_gl_line_width_t : identifier;
pen_gl_line_width_granularity_t : identifier;
pen_gl_line_width_range_t : identifier;
pen_glpolygons_t : identifier;
pen_gl_point_t : identifier;
pen_gl_line_t : identifier;
pen_gl_fill_t : identifier;
pen_gl_cw_t : identifier;
pen_gl_ccw_t : identifier;
pen_gl_front_t : identifier;
pen_gl_back_t : identifier;
pen_gl_polygon_mode_t : identifier;
pen_gl_polygon_smooth_t : identifier;
pen_gl_polygon_stipple_t : identifier;
pen_gl_edge_flag_t : identifier;
pen_gl_cull_face_t : identifier;
pen_gl_cull_face_mode_t : identifier;
pen_gl_front_face_t : identifier;
pen_gl_polygon_offset_factor_t : identifier;
pen_gl_polygon_offset_units_t : identifier;
pen_gl_polygon_offset_point_t : identifier;
pen_gl_polygon_offset_line_t : identifier;
pen_gl_polygon_offset_fill_t : identifier;
pen_gldlists_t : identifier;
pen_gl_compile_t : identifier;
pen_gl_compile_and_execute_t : identifier;
pen_gl_list_base_t : identifier;
pen_gl_list_index_t : identifier;
pen_gl_list_mode_t : identifier;
pen_glalphacompare_t : identifier;
pen_gl_never_t : identifier;
pen_gl_less_t : identifier;
pen_gl_equal_t : identifier;
pen_gl_lequal_t : identifier;
pen_gl_greater_t : identifier;
pen_gl_notequal_t : identifier;
pen_gl_gequal_t : identifier;
pen_gl_always_t : identifier;
pen_gldbuffer_t : identifier;
pen_gl_depth_test_t : identifier;
pen_gl_depth_bits_t : identifier;
pen_gl_depth_clear_value_t : identifier;
pen_gl_depth_func_t : identifier;
pen_gl_depth_range_t : identifier;
pen_gl_depth_writemask_t : identifier;
pen_gl_depth_component_t : identifier;
pen_gllighting_t : identifier;
pen_gl_lighting_t : identifier;
pen_gl_light0_t : identifier;
pen_gl_light1_t : identifier;
pen_gl_light2_t : identifier;
pen_gl_light3_t : identifier;
pen_gl_light4_t : identifier;
pen_gl_light5_t : identifier;
pen_gl_light6_t : identifier;
pen_gl_light7_t : identifier;
pen_gl_spot_exponent_t : identifier;
pen_gl_spot_cutoff_t : identifier;
pen_gl_constant_attenuation_t : identifier;
pen_gl_linear_attenuation_t : identifier;
pen_gl_quadratic_attenuation_t : identifier;
pen_gl_ambient_t : identifier;
pen_gl_diffuse_t : identifier;
pen_gl_specular_t : identifier;
pen_gl_shininess_t : identifier;
pen_gl_emission_t : identifier;
pen_gl_position_t : identifier;
pen_gl_spot_direction_t : identifier;
pen_gl_ambient_and_diffuse_t : identifier;
pen_gl_color_indexes_t : identifier;
pen_gl_light_model_two_side_t : identifier;
pen_gl_light_model_local_viewer_t : identifier;
pen_gl_light_model_ambient_t : identifier;
pen_gl_front_and_back_t : identifier;
pen_gl_shade_model_t : identifier;
pen_gl_flat_t : identifier;
pen_gl_smooth_t : identifier;
pen_gl_color_material_t : identifier;
pen_gl_color_material_face_t : identifier;
pen_gl_color_material_parameter_t : identifier;
pen_gl_normalize_t : identifier;
pen_glusercplane_t : identifier;
pen_gl_clip_plane0_t : identifier;
pen_gl_clip_plane1_t : identifier;
pen_gl_clip_plane2_t : identifier;
pen_gl_clip_plane3_t : identifier;
pen_gl_clip_plane4_t : identifier;
pen_gl_clip_plane5_t : identifier;
pen_glabuffer_t : identifier;
pen_gl_accum_red_bits_t : identifier;
pen_gl_accum_green_bits_t : identifier;
pen_gl_accum_blue_bits_t : identifier;
pen_gl_accum_alpha_bits_t : identifier;
pen_gl_accum_clear_value_t : identifier;
pen_gl_accum_t : identifier;
pen_gl_add_t : identifier;
pen_gl_load_t : identifier;
pen_gl_mult_t : identifier;
pen_gl_return_t : identifier;
pen_glatesting_t : identifier;
pen_gl_alpha_test_t : identifier;
pen_gl_alpha_test_ref_t : identifier;
pen_gl_alpha_test_func_t : identifier;
pen_glblending_t : identifier;
pen_gl_blend_t : identifier;
pen_gl_blend_src_t : identifier;
pen_gl_blend_dst_t : identifier;
pen_gl_zero_t : identifier;
pen_gl_one_t : identifier;
pen_gl_src_color_t : identifier;
pen_gl_one_minus_src_color_t : identifier;
pen_gl_src_alpha_t : identifier;
pen_gl_one_minus_src_alpha_t : identifier;
pen_gl_dst_alpha_t : identifier;
pen_gl_one_minus_dst_alpha_t : identifier;
pen_gl_dst_color_t : identifier;
pen_gl_one_minus_dst_color_t : identifier;
pen_gl_src_alpha_saturate_t : identifier;
pen_glrendermodes_t : identifier;
pen_gl_feedback_t : identifier;
pen_gl_render_t : identifier;
pen_gl_select_t : identifier;
pen_glfeedback_t : identifier;
pen_gl_2d_t : identifier;
pen_gl_3d_t : identifier;
pen_gl_3d_color_t : identifier;
pen_gl_3d_color_texture_t : identifier;
pen_gl_4d_color_texture_t : identifier;
pen_gl_point_token_t : identifier;
pen_gl_line_token_t : identifier;
pen_gl_line_reset_token_t : identifier;
pen_gl_polygon_token_t : identifier;
pen_gl_bitmap_token_t : identifier;
pen_gl_draw_pixel_token_t : identifier;
pen_gl_copy_pixel_token_t : identifier;
pen_gl_pass_through_token_t : identifier;
pen_gl_feedback_buffer_pointer_t : identifier;
pen_gl_feedback_buffer_size_t : identifier;
pen_gl_feedback_buffer_type_t : identifier;
pen_glselection_t : identifier;
pen_gl_selection_buffer_pointer_t : identifier;
pen_gl_selection_buffer_size_t : identifier;
pen_glfog_t : identifier;
pen_gl_fog_t : identifier;
pen_gl_fog_mode_t : identifier;
pen_gl_fog_density_t : identifier;
pen_gl_fog_color_t : identifier;
pen_gl_fog_index_t : identifier;
pen_gl_fog_start_t : identifier;
pen_gl_fog_end_t : identifier;
pen_gl_linear_t : identifier;
pen_gl_exp_t : identifier;
pen_gl_exp2_t : identifier;
pen_gllogicops_t : identifier;
pen_gl_logic_op_t : identifier;
pen_gl_index_logic_op_t : identifier;
pen_gl_color_logic_op_t : identifier;
pen_gl_logic_op_mode_t : identifier;
pen_gl_clear_t : identifier;
pen_gl_set_t : identifier;
pen_gl_copy_t : identifier;
pen_gl_copy_inverted_t : identifier;
pen_gl_noop_t : identifier;
pen_gl_invert_t : identifier;
pen_gl_and_t : identifier;
pen_gl_nand_t : identifier;
pen_gl_or_t : identifier;
pen_gl_nor_t : identifier;
pen_gl_xor_t : identifier;
pen_gl_equiv_t : identifier;
pen_gl_and_reverse_t : identifier;
pen_gl_and_inverted_t : identifier;
pen_gl_or_reverse_t : identifier;
pen_gl_or_inverted_t : identifier;
pen_glstencil_t : identifier;
pen_gl_stencil_bits_t : identifier;
pen_gl_stencil_test_t : identifier;
pen_gl_stencil_clear_value_t : identifier;
pen_gl_stencil_func_t : identifier;
pen_gl_stencil_value_mask_t : identifier;
pen_gl_stencil_fail_t : identifier;
pen_gl_stencil_pass_depth_fail_t : identifier;
pen_gl_stencil_pass_depth_pass_t : identifier;
pen_gl_stencil_ref_t : identifier;
pen_gl_stencil_writemask_t : identifier;
pen_gl_stencil_index_t : identifier;
pen_gl_keep_t : identifier;
pen_gl_replace_t : identifier;
pen_gl_incr_t : identifier;
pen_gl_decr_t : identifier;
pen_glbuffers_t : identifier;
pen_gl_none_t : identifier;
pen_gl_left_t : identifier;
pen_gl_right_t : identifier;
pen_gl_front_left_t : identifier;
pen_gl_front_right_t : identifier;
pen_gl_back_left_t : identifier;
pen_gl_back_right_t : identifier;
pen_gl_aux0_t : identifier;
pen_gl_aux1_t : identifier;
pen_gl_aux2_t : identifier;
pen_gl_aux3_t : identifier;
pen_gl_color_index_t : identifier;
pen_gl_red_t : identifier;
pen_gl_green_t : identifier;
pen_gl_blue_t : identifier;
pen_gl_alpha_t : identifier;
pen_gl_luminance_t : identifier;
pen_gl_luminance_alpha_t : identifier;
pen_gl_alpha_bits_t : identifier;
pen_gl_red_bits_t : identifier;
pen_gl_green_bits_t : identifier;
pen_gl_blue_bits_t : identifier;
pen_gl_index_bits_t : identifier;
pen_gl_subpixel_bits_t : identifier;
pen_gl_aux_buffers_t : identifier;
pen_gl_read_buffer_t : identifier;
pen_gl_draw_buffer_t : identifier;
pen_gl_doublebuffer_t : identifier;
pen_gl_stereo_t : identifier;
pen_gl_bitmap_t : identifier;
pen_gl_color_t : identifier;
pen_gl_depth_t : identifier;
pen_gl_stencil_t : identifier;
pen_gl_dither_t : identifier;
pen_gl_rgb_t : identifier;
pen_gl_rgba_t : identifier;
pen_gllimits_t : identifier;
pen_gl_max_list_nesting_t : identifier;
pen_gl_max_eval_order_t : identifier;
pen_gl_max_lights_t : identifier;
pen_gl_max_clip_planes_t : identifier;
pen_gl_max_texture_size_t : identifier;
pen_gl_max_pixel_map_table_t : identifier;
pen_gl_max_attrib_stack_depth_t : identifier;
pen_gl_max_modelview_stack_depth_t : identifier;
pen_gl_max_name_stack_depth_t : identifier;
pen_gl_max_projection_stack_depth_t : identifier;
pen_gl_max_texture_stack_depth_t : identifier;
pen_gl_max_viewport_dims_t : identifier;
pen_gl_max_client_attrib_stack_depth_t : identifier;
pen_gl_attrib_stack_depth_t : identifier;
pen_gl_client_attrib_stack_depth_t : identifier;
pen_glgets_t : identifier;
pen_gl_color_clear_value_t : identifier;
pen_gl_color_writemask_t : identifier;
pen_gl_current_index_t : identifier;
pen_gl_current_color_t : identifier;
pen_gl_current_normal_t : identifier;
pen_gl_current_raster_color_t : identifier;
pen_gl_current_raster_distance_t : identifier;
pen_gl_current_raster_index_t : identifier;
pen_gl_current_raster_position_t : identifier;
pen_gl_current_raster_texture_coords_t : identifier;
pen_gl_current_raster_position_valid_t : identifier;
pen_gl_current_texture_coords_t : identifier;
pen_gl_index_clear_value_t : identifier;
pen_gl_index_mode_t : identifier;
pen_gl_index_writemask_t : identifier;
pen_gl_modelview_matrix_t : identifier;
pen_gl_modelview_stack_depth_t : identifier;
pen_gl_name_stack_depth_t : identifier;
pen_gl_projection_matrix_t : identifier;
pen_gl_projection_stack_depth_t : identifier;
pen_gl_render_mode_t : identifier;
pen_gl_rgba_mode_t : identifier;
pen_gl_texture_matrix_t : identifier;
pen_gl_texture_stack_depth_t : identifier;
pen_gl_viewport_t : identifier;
pen_glevaluators_t : identifier;
pen_gl_auto_normal_t : identifier;
pen_gl_map1_color_4_t : identifier;
pen_gl_map1_index_t : identifier;
pen_gl_map1_normal_t : identifier;
pen_gl_map1_texture_coord_1_t : identifier;
pen_gl_map1_texture_coord_2_t : identifier;
pen_gl_map1_texture_coord_3_t : identifier;
pen_gl_map1_texture_coord_4_t : identifier;
pen_gl_map1_vertex_3_t : identifier;
pen_gl_map1_vertex_4_t : identifier;
pen_gl_map2_color_4_t : identifier;
pen_gl_map2_index_t : identifier;
pen_gl_map2_normal_t : identifier;
pen_gl_map2_texture_coord_1_t : identifier;
pen_gl_map2_texture_coord_2_t : identifier;
pen_gl_map2_texture_coord_3_t : identifier;
pen_gl_map2_texture_coord_4_t : identifier;
pen_gl_map2_vertex_3_t : identifier;
pen_gl_map2_vertex_4_t : identifier;
pen_gl_map1_grid_domain_t : identifier;
pen_gl_map1_grid_segments_t : identifier;
pen_gl_map2_grid_domain_t : identifier;
pen_gl_map2_grid_segments_t : identifier;
pen_gl_coeff_t : identifier;
pen_gl_order_t : identifier;
pen_gl_domain_t : identifier;
pen_glhints_t : identifier;
pen_gl_perspective_correction_hint_t : identifier;
pen_gl_point_smooth_hint_t : identifier;
pen_gl_line_smooth_hint_t : identifier;
pen_gl_polygon_smooth_hint_t : identifier;
pen_gl_fog_hint_t : identifier;
pen_glhintmodes_t : identifier;
pen_gl_dont_care_t : identifier;
pen_gl_fastest_t : identifier;
pen_gl_nicest_t : identifier;
pen_glscissorbox_t : identifier;
pen_gl_scissor_box_t : identifier;
pen_gl_scissor_test_t : identifier;
pen_glpixelmode_t : identifier;
pen_gl_map_color_t : identifier;
pen_gl_map_stencil_t : identifier;
pen_gl_index_shift_t : identifier;
pen_gl_index_offset_t : identifier;
pen_gl_red_scale_t : identifier;
pen_gl_red_bias_t : identifier;
pen_gl_green_scale_t : identifier;
pen_gl_green_bias_t : identifier;
pen_gl_blue_scale_t : identifier;
pen_gl_blue_bias_t : identifier;
pen_gl_alpha_scale_t : identifier;
pen_gl_alpha_bias_t : identifier;
pen_gl_depth_scale_t : identifier;
pen_gl_depth_bias_t : identifier;
pen_gl_pixel_map_s_to_s_size_t : identifier;
pen_gl_pixel_map_i_to_i_size_t : identifier;
pen_gl_pixel_map_i_to_r_size_t : identifier;
pen_gl_pixel_map_i_to_g_size_t : identifier;
pen_gl_pixel_map_i_to_b_size_t : identifier;
pen_gl_pixel_map_i_to_a_size_t : identifier;
pen_gl_pixel_map_r_to_r_size_t : identifier;
pen_gl_pixel_map_g_to_g_size_t : identifier;
pen_gl_pixel_map_b_to_b_size_t : identifier;
pen_gl_pixel_map_a_to_a_size_t : identifier;
pen_gl_pixel_map_s_to_s_t : identifier;
pen_gl_pixel_map_i_to_i_t : identifier;
pen_gl_pixel_map_i_to_r_t : identifier;
pen_gl_pixel_map_i_to_g_t : identifier;
pen_gl_pixel_map_i_to_b_t : identifier;
pen_gl_pixel_map_i_to_a_t : identifier;
pen_gl_pixel_map_r_to_r_t : identifier;
pen_gl_pixel_map_g_to_g_t : identifier;
pen_gl_pixel_map_b_to_b_t : identifier;
pen_gl_pixel_map_a_to_a_t : identifier;
pen_gl_pack_alignment_t : identifier;
pen_gl_pack_lsb_first_t : identifier;
pen_gl_pack_row_length_t : identifier;
pen_gl_pack_skip_pixels_t : identifier;
pen_gl_pack_skip_rows_t : identifier;
pen_gl_pack_swap_bytes_t : identifier;
pen_gl_unpack_alignment_t : identifier;
pen_gl_unpack_lsb_first_t : identifier;
pen_gl_unpack_row_length_t : identifier;
pen_gl_unpack_skip_pixels_t : identifier;
pen_gl_unpack_skip_rows_t : identifier;
pen_gl_unpack_swap_bytes_t : identifier;
pen_gl_zoom_x_t : identifier;
pen_gl_zoom_y_t : identifier;
pen_gltexturemapping_t : identifier;
pen_gl_texture_env_t : identifier;
pen_gl_texture_env_mode_t : identifier;
pen_gl_texture_1d_t : identifier;
pen_gl_texture_2d_t : identifier;
pen_gl_texture_wrap_s_t : identifier;
pen_gl_texture_wrap_t_t : identifier;
pen_gl_texture_mag_filter_t : identifier;
pen_gl_texture_min_filter_t : identifier;
pen_gl_texture_env_color_t : identifier;
pen_gl_texture_gen_s_t : identifier;
pen_gl_texture_gen_t_t : identifier;
pen_gl_texture_gen_mode_t : identifier;
pen_gl_texture_border_color_t : identifier;
pen_gl_texture_width_t : identifier;
pen_gl_texture_height_t : identifier;
pen_gl_texture_border_t : identifier;
pen_gl_texture_components_t : identifier;
pen_gl_texture_red_size_t : identifier;
pen_gl_texture_green_size_t : identifier;
pen_gl_texture_blue_size_t : identifier;
pen_gl_texture_alpha_size_t : identifier;
pen_gl_texture_luminance_size_t : identifier;
pen_gl_texture_intensity_size_t : identifier;
pen_gl_nearest_mipmap_nearest_t : identifier;
pen_gl_nearest_mipmap_linear_t : identifier;
pen_gl_linear_mipmap_nearest_t : identifier;
pen_gl_linear_mipmap_linear_t : identifier;
pen_gl_object_linear_t : identifier;
pen_gl_object_plane_t : identifier;
pen_gl_eye_linear_t : identifier;
pen_gl_eye_plane_t : identifier;
pen_gl_sphere_map_t : identifier;
pen_gl_decal_t : identifier;
pen_gl_modulate_t : identifier;
pen_gl_nearest_t : identifier;
pen_gl_repeat_t : identifier;
pen_gl_clamp_t : identifier;
pen_gl_s_t : identifier;
pen_gl_t_t : identifier;
pen_gl_r_t : identifier;
pen_gl_q_t : identifier;
pen_gl_texture_gen_r_t : identifier;
pen_gl_texture_gen_q_t : identifier;
pen_glutility_t : identifier;
pen_gl_vendor_t : identifier;
pen_gl_renderer_t : identifier;
pen_gl_version_t : identifier;
pen_gl_extensions_t : identifier;
pen_glerrors_t : identifier;
pen_gl_no_error_t : identifier;
pen_gl_invalid_enum_t : identifier;
pen_gl_invalid_value_t : identifier;
pen_gl_invalid_operation_t : identifier;
pen_gl_stack_overflow_t : identifier;
pen_gl_stack_underflow_t : identifier;
pen_gl_out_of_memory_t : identifier;
pen_glpushbits_t : identifier;
pen_gl_current_bit_t : identifier;
pen_gl_point_bit_t : identifier;
pen_gl_line_bit_t : identifier;
pen_gl_polygon_bit_t : identifier;
pen_gl_polygon_stipple_bit_t : identifier;
pen_gl_pixel_mode_bit_t : identifier;
pen_gl_lighting_bit_t : identifier;
pen_gl_fog_bit_t : identifier;
pen_gl_depth_buffer_bit_t : identifier;
pen_gl_accum_buffer_bit_t : identifier;
pen_gl_stencil_buffer_bit_t : identifier;
pen_gl_viewport_bit_t : identifier;
pen_gl_transform_bit_t : identifier;
pen_gl_enable_bit_t : identifier;
pen_gl_color_buffer_bit_t : identifier;
pen_gl_hint_bit_t : identifier;
pen_gl_eval_bit_t : identifier;
pen_gl_list_bit_t : identifier;
pen_gl_texture_bit_t : identifier;
pen_gl_scissor_bit_t : identifier;
pen_gl_all_attrib_bits_t : identifier;
pen_gl_proxy_texture_1d_t : identifier;
pen_gl_proxy_texture_2d_t : identifier;
pen_gl_texture_priority_t : identifier;
pen_gl_texture_resident_t : identifier;
pen_gl_texture_binding_1d_t : identifier;
pen_gl_texture_binding_2d_t : identifier;
pen_gl_texture_internal_format_t : identifier;
pen_gl_alpha4_t : identifier;
pen_gl_alpha8_t : identifier;
pen_gl_alpha12_t : identifier;
pen_gl_alpha16_t : identifier;
pen_gl_luminance4_t : identifier;
pen_gl_luminance8_t : identifier;
pen_gl_luminance12_t : identifier;
pen_gl_luminance16_t : identifier;
pen_gl_luminance4_alpha4_t : identifier;
pen_gl_luminance6_alpha2_t : identifier;
pen_gl_luminance8_alpha8_t : identifier;
pen_gl_luminance12_alpha4_t : identifier;
pen_gl_luminance12_alpha12_t : identifier;
pen_gl_luminance16_alpha16_t : identifier;
pen_gl_intensity_t : identifier;
pen_gl_intensity4_t : identifier;
pen_gl_intensity8_t : identifier;
pen_gl_intensity12_t : identifier;
pen_gl_intensity16_t : identifier;
pen_gl_r3_g3_b2_t : identifier;
pen_gl_rgb4_t : identifier;
pen_gl_rgb5_t : identifier;
pen_gl_rgb8_t : identifier;
pen_gl_rgb10_t : identifier;
pen_gl_rgb12_t : identifier;
pen_gl_rgb16_t : identifier;
pen_gl_rgba2_t : identifier;
pen_gl_rgba4_t : identifier;
pen_gl_rgb5_a1_t : identifier;
pen_gl_rgba8_t : identifier;
pen_gl_rgb10_a2_t : identifier;
pen_gl_rgba12_t : identifier;
pen_gl_rgba16_t : identifier;
pen_gl_client_pixel_store_bit_t : identifier;
pen_gl_client_vertex_array_bit_t : identifier;
pen_gl_all_client_attrib_bits_t : identifier;
pen_gl_client_all_attrib_bits_t : identifier;
pen_gl_rescale_normal_t : identifier;
pen_gl_clamp_to_edge_t : identifier;
pen_gl_max_elements_vertices_t : identifier;
pen_gl_max_elements_indices_t : identifier;
pen_gl_bgr_t : identifier;
pen_gl_bgra_t : identifier;
pen_gl_unsigned_byte_3_3_2_t : identifier;
pen_gl_unsigned_byte_2_3_3_rev_t : identifier;
pen_gl_unsigned_short_5_6_5_t : identifier;
pen_gl_unsigned_short_5_6_5_rev_t : identifier;
pen_gl_unsigned_short_4_4_4_4_t : identifier;
pen_gl_unsigned_short_4_4_4_4_rev_t : identifier;
pen_gl_unsigned_short_5_5_5_1_t : identifier;
pen_gl_unsigned_short_1_5_5_5_rev_t : identifier;
pen_gl_unsigned_int_8_8_8_8_t : identifier;
pen_gl_unsigned_int_8_8_8_8_rev_t : identifier;
pen_gl_unsigned_int_10_10_10_2_t : identifier;
pen_gl_unsigned_int_2_10_10_10_rev_t : identifier;
pen_gl_light_model_color_control_t : identifier;
pen_gl_single_color_t : identifier;
pen_gl_separate_specular_color_t : identifier;
pen_gl_texture_min_lod_t : identifier;
pen_gl_texture_max_lod_t : identifier;
pen_gl_texture_base_level_t : identifier;
pen_gl_texture_max_level_t : identifier;
pen_gl_smooth_point_size_range_t : identifier;
pen_gl_smooth_point_size_granularity_t : identifier;
pen_gl_smooth_line_width_range_t : identifier;
pen_gl_smooth_line_width_granularity_t : identifier;
pen_gl_aliased_point_size_range_t : identifier;
pen_gl_aliased_line_width_range_t : identifier;
pen_gl_pack_skip_images_t : identifier;
pen_gl_pack_image_height_t : identifier;
pen_gl_unpack_skip_images_t : identifier;
pen_gl_unpack_image_height_t : identifier;
pen_gl_texture_3d_t : identifier;
pen_gl_proxy_texture_3d_t : identifier;
pen_gl_texture_depth_t : identifier;
pen_gl_texture_wrap_r_t : identifier;
pen_gl_max_3d_texture_size_t : identifier;
pen_gl_texture_binding_3d_t : identifier;
pen_glarbmapping_t : identifier;
pen_gl_constant_color_t : identifier;
pen_gl_one_minus_constant_color_t : identifier;
pen_gl_constant_alpha_t : identifier;
pen_gl_one_minus_constant_alpha_t : identifier;
pen_gl_color_table_t : identifier;
pen_gl_post_convolution_color_table_t : identifier;
pen_gl_post_color_matrix_color_table_t : identifier;
pen_gl_proxy_color_table_t : identifier;
pen_gl_proxy_post_convolution_color_table_t : identifier;
pen_gl_proxy_post_color_matrix_color_table_t : identifier;
pen_gl_color_table_scale_t : identifier;
pen_gl_color_table_bias_t : identifier;
pen_gl_color_table_format_t : identifier;
pen_gl_color_table_width_t : identifier;
pen_gl_color_table_red_size_t : identifier;
pen_gl_color_table_green_size_t : identifier;
pen_gl_color_table_blue_size_t : identifier;
pen_gl_color_table_alpha_size_t : identifier;
pen_gl_color_table_luminance_size_t : identifier;
pen_gl_color_table_intensity_size_t : identifier;
pen_gl_convolution_1d_t : identifier;
pen_gl_convolution_2d_t : identifier;
pen_gl_separable_2d_t : identifier;
pen_gl_convolution_border_mode_t : identifier;
pen_gl_convolution_filter_scale_t : identifier;
pen_gl_convolution_filter_bias_t : identifier;
pen_gl_reduce_t : identifier;
pen_gl_convolution_format_t : identifier;
pen_gl_convolution_width_t : identifier;
pen_gl_convolution_height_t : identifier;
pen_gl_max_convolution_width_t : identifier;
pen_gl_max_convolution_height_t : identifier;
pen_gl_post_convolution_red_scale_t : identifier;
pen_gl_post_convolution_green_scale_t : identifier;
pen_gl_post_convolution_blue_scale_t : identifier;
pen_gl_post_convolution_alpha_scale_t : identifier;
pen_gl_post_convolution_red_bias_t : identifier;
pen_gl_post_convolution_green_bias_t : identifier;
pen_gl_post_convolution_blue_bias_t : identifier;
pen_gl_post_convolution_alpha_bias_t : identifier;
pen_gl_constant_border_t : identifier;
pen_gl_replicate_border_t : identifier;
pen_gl_convolution_border_color_t : identifier;
pen_gl_color_matrix_t : identifier;
pen_gl_color_matrix_stack_depth_t : identifier;
pen_gl_max_color_matrix_stack_depth_t : identifier;
pen_gl_post_color_matrix_red_scale_t : identifier;
pen_gl_post_color_matrix_green_scale_t : identifier;
pen_gl_post_color_matrix_blue_scale_t : identifier;
pen_gl_post_color_matrix_alpha_scale_t : identifier;
pen_gl_post_color_matrix_red_bias_t : identifier;
pen_gl_post_color_matrix_green_bias_t : identifier;
pen_gl_post_color_matrix_blue_bias_t : identifier;
pen_gl_post_color_matrix_alpha_bias_t : identifier;
pen_gl_histogram_t : identifier;
pen_gl_proxy_histogram_t : identifier;
pen_gl_histogram_width_t : identifier;
pen_gl_histogram_format_t : identifier;
pen_gl_histogram_red_size_t : identifier;
pen_gl_histogram_green_size_t : identifier;
pen_gl_histogram_blue_size_t : identifier;
pen_gl_histogram_alpha_size_t : identifier;
pen_gl_histogram_luminance_size_t : identifier;
pen_gl_histogram_sink_t : identifier;
pen_gl_minmax_t : identifier;
pen_gl_minmax_format_t : identifier;
pen_gl_minmax_sink_t : identifier;
pen_gl_table_too_large_t : identifier;
pen_gl_blend_equation_t : identifier;
pen_gl_min_t : identifier;
pen_gl_max_t : identifier;
pen_gl_func_add_t : identifier;
pen_gl_func_subtract_t : identifier;
pen_gl_func_reverse_subtract_t : identifier;
pen_gl_blend_color_t : identifier;
pen_glmultitexture_t : identifier;
pen_gl_texture0_t : identifier;
pen_gl_texture1_t : identifier;
pen_gl_texture2_t : identifier;
pen_gl_texture3_t : identifier;
pen_gl_texture4_t : identifier;
pen_gl_texture5_t : identifier;
pen_gl_texture6_t : identifier;
pen_gl_texture7_t : identifier;
pen_gl_texture8_t : identifier;
pen_gl_texture9_t : identifier;
pen_gl_texture10_t : identifier;
pen_gl_texture11_t : identifier;
pen_gl_texture12_t : identifier;
pen_gl_texture13_t : identifier;
pen_gl_texture14_t : identifier;
pen_gl_texture15_t : identifier;
pen_gl_texture16_t : identifier;
pen_gl_texture17_t : identifier;
pen_gl_texture18_t : identifier;
pen_gl_texture19_t : identifier;
pen_gl_texture20_t : identifier;
pen_gl_texture21_t : identifier;
pen_gl_texture22_t : identifier;
pen_gl_texture23_t : identifier;
pen_gl_texture24_t : identifier;
pen_gl_texture25_t : identifier;
pen_gl_texture26_t : identifier;
pen_gl_texture27_t : identifier;
pen_gl_texture28_t : identifier;
pen_gl_texture29_t : identifier;
pen_gl_texture30_t : identifier;
pen_gl_texture31_t : identifier;
pen_gl_active_texture_t : identifier;
pen_gl_client_active_texture_t : identifier;
pen_gl_max_texture_units_t : identifier;
pen_gltexturecubemap_t : identifier;
pen_gl_normal_map_t : identifier;
pen_gl_reflection_map_t : identifier;
pen_gl_texture_cube_map_t : identifier;
pen_gl_texture_binding_cube_map_t : identifier;
pen_gl_texture_cube_map_positive_x_t : identifier;
pen_gl_texture_cube_map_negative_x_t : identifier;
pen_gl_texture_cube_map_positive_y_t : identifier;
pen_gl_texture_cube_map_negative_y_t : identifier;
pen_gl_texture_cube_map_positive_z_t : identifier;
pen_gl_texture_cube_map_negative_z_t : identifier;
pen_gl_proxy_texture_cube_map_t : identifier;
pen_gl_max_cube_map_texture_size_t : identifier;
pen_gltexturecomp_t : identifier;
pen_gl_compressed_alpha_t : identifier;
pen_gl_compressed_luminance_t : identifier;
pen_gl_compressed_luminance_alpha_t : identifier;
pen_gl_compressed_intensity_t : identifier;
pen_gl_compressed_rgb_t : identifier;
pen_gl_compressed_rgba_t : identifier;
pen_gl_texture_compression_hint_t : identifier;
pen_gl_texture_compressed_image_size_t : identifier;
pen_gl_texture_compressed_t : identifier;
pen_gl_num_compressed_texture_formats_t : identifier;
pen_gl_compressed_texture_formats_t : identifier;
pen_glmultisample_t : identifier;
pen_gl_multisample_t : identifier;
pen_gl_sample_alpha_to_coverage_t : identifier;
pen_gl_sample_alpha_to_one_t : identifier;
pen_gl_sample_coverage_t : identifier;
pen_gl_sample_buffers_t : identifier;
pen_gl_samples_t : identifier;
pen_gl_sample_coverage_value_t : identifier;
pen_gl_sample_coverage_invert_t : identifier;
pen_gl_multisample_bit_t : identifier;
pen_gltransposemat_t : identifier;
pen_gl_transpose_modelview_matrix_t : identifier;
pen_gl_transpose_projection_matrix_t : identifier;
pen_gl_transpose_texture_matrix_t : identifier;
pen_gl_transpose_color_matrix_t : identifier;
pen_gltextureenvcomb_t : identifier;
pen_gl_combine_t : identifier;
pen_gl_combine_rgb_t : identifier;
pen_gl_combine_alpha_t : identifier;
pen_gl_source0_rgb_t : identifier;
pen_gl_source1_rgb_t : identifier;
pen_gl_source2_rgb_t : identifier;
pen_gl_source0_alpha_t : identifier;
pen_gl_source1_alpha_t : identifier;
pen_gl_source2_alpha_t : identifier;
pen_gl_operand0_rgb_t : identifier;
pen_gl_operand1_rgb_t : identifier;
pen_gl_operand2_rgb_t : identifier;
pen_gl_operand0_alpha_t : identifier;
pen_gl_operand1_alpha_t : identifier;
pen_gl_operand2_alpha_t : identifier;
pen_gl_rgb_scale_t : identifier;
pen_gl_add_signed_t : identifier;
pen_gl_interpolate_t : identifier;
pen_gl_subtract_t : identifier;
pen_gl_constant_t : identifier;
pen_gl_primary_color_t : identifier;
pen_gl_previous_t : identifier;
pen_gltextureenvdot3_t : identifier;
pen_gl_dot3_rgb_t : identifier;
pen_gl_dot3_rgba_t : identifier;
pen_gl_clamp_to_border_t : identifier;
pen_glmultitexturearb_t : identifier;
pen_gl_texture0_arb_t : identifier;
pen_gl_texture1_arb_t : identifier;
pen_gl_texture2_arb_t : identifier;
pen_gl_texture3_arb_t : identifier;
pen_gl_texture4_arb_t : identifier;
pen_gl_texture5_arb_t : identifier;
pen_gl_texture6_arb_t : identifier;
pen_gl_texture7_arb_t : identifier;
pen_gl_texture8_arb_t : identifier;
pen_gl_texture9_arb_t : identifier;
pen_gl_texture10_arb_t : identifier;
pen_gl_texture11_arb_t : identifier;
pen_gl_texture12_arb_t : identifier;
pen_gl_texture13_arb_t : identifier;
pen_gl_texture14_arb_t : identifier;
pen_gl_texture15_arb_t : identifier;
pen_gl_texture16_arb_t : identifier;
pen_gl_texture17_arb_t : identifier;
pen_gl_texture18_arb_t : identifier;
pen_gl_texture19_arb_t : identifier;
pen_gl_texture20_arb_t : identifier;
pen_gl_texture21_arb_t : identifier;
pen_gl_texture22_arb_t : identifier;
pen_gl_texture23_arb_t : identifier;
pen_gl_texture24_arb_t : identifier;
pen_gl_texture25_arb_t : identifier;
pen_gl_texture26_arb_t : identifier;
pen_gl_texture27_arb_t : identifier;
pen_gl_texture28_arb_t : identifier;
pen_gl_texture29_arb_t : identifier;
pen_gl_texture30_arb_t : identifier;
pen_gl_texture31_arb_t : identifier;
pen_gl_active_texture_arb_t : identifier;
pen_gl_client_active_texture_arb_t : identifier;
pen_gl_max_texture_units_arb_t : identifier;
pen_gldebugshaders_t : identifier;
pen_gl_debug_object_mesa_t : identifier;
pen_gl_debug_print_mesa_t : identifier;
pen_gl_debug_assert_mesa_t : identifier;
pen_globsolete_t : identifier;
pen_gl_depth_stencil_mesa_t : identifier;
pen_gl_unsigned_int_24_8_mesa_t : identifier;
pen_gl_unsigned_int_8_24_rev_mesa_t : identifier;
pen_gl_unsigned_short_15_1_mesa_t : identifier;
pen_gl_unsigned_short_1_15_rev_mesa_t : identifier;
pen_gl_fragment_program_position_mesa_t : identifier;
pen_gl_fragment_program_callback_mesa_t : identifier;
pen_gl_fragment_program_callback_func_mesa_t : identifier;
pen_gl_fragment_program_callback_data_mesa_t : identifier;
pen_gl_vertex_program_position_mesa_t : identifier;
pen_gl_vertex_program_callback_mesa_t : identifier;
pen_gl_vertex_program_callback_func_mesa_t : identifier;
pen_gl_vertex_program_callback_data_mesa_t : identifier;
pen_gl_texture_1d_array_ext_t : identifier;
pen_gl_proxy_texture_1d_array_ext_t : identifier;
pen_gl_texture_2d_array_ext_t : identifier;
pen_gl_proxy_texture_2d_array_ext_t : identifier;
pen_gl_texture_binding_1d_array_ext_t : identifier;
pen_gl_texture_binding_2d_array_ext_t : identifier;
pen_gl_max_array_texture_layers_ext_t : identifier;
pen_gl_framebuffer_attachment_texture_layer_ext_t : identifier;
pen_gl_alpha_blend_equation_ati_t : identifier;
pen_glu_ext_object_space_tess_t : identifier;
pen_glu_ext_nurbs_tessellator_t : identifier;
pen_glu_false_t : identifier;
pen_glu_true_t : identifier;
pen_glu_version_1_1_t : identifier;
pen_glu_version_1_2_t : identifier;
pen_glu_version_1_3_t : identifier;
pen_glu_version_t : identifier;
pen_glu_extensions_t : identifier;
pen_glu_invalid_enum_t : identifier;
pen_glu_invalid_value_t : identifier;
pen_glu_out_of_memory_t : identifier;
pen_glu_incompatible_gl_version_t : identifier;
pen_glu_invalid_operation_t : identifier;
pen_glu_outline_polygon_t : identifier;
pen_glu_outline_patch_t : identifier;
pen_glunurbscallbacks_t : identifier;
pen_glu_nurbs_error_t : identifier;
pen_glu_error_t : identifier;
pen_glu_nurbs_begin_t : identifier;
pen_glu_nurbs_begin_ext_t : identifier;
pen_glu_nurbs_vertex_t : identifier;
pen_glu_nurbs_vertex_ext_t : identifier;
pen_glu_nurbs_normal_t : identifier;
pen_glu_nurbs_normal_ext_t : identifier;
pen_glu_nurbs_color_t : identifier;
pen_glu_nurbs_color_ext_t : identifier;
pen_glu_nurbs_texture_coord_t : identifier;
pen_glu_nurbs_tex_coord_ext_t : identifier;
pen_glu_nurbs_end_t : identifier;
pen_glu_nurbs_end_ext_t : identifier;
pen_glu_nurbs_begin_data_t : identifier;
pen_glu_nurbs_begin_data_ext_t : identifier;
pen_glu_nurbs_vertex_data_t : identifier;
pen_glu_nurbs_vertex_data_ext_t : identifier;
pen_glu_nurbs_normal_data_t : identifier;
pen_glu_nurbs_normal_data_ext_t : identifier;
pen_glu_nurbs_color_data_t : identifier;
pen_glu_nurbs_color_data_ext_t : identifier;
pen_glu_nurbs_texture_coord_data_t : identifier;
pen_glu_nurbs_tex_coord_data_ext_t : identifier;
pen_glu_nurbs_end_data_t : identifier;
pen_glu_nurbs_end_data_ext_t : identifier;
pen_glu_nurbs_error1_t : identifier;
pen_glu_nurbs_error2_t : identifier;
pen_glu_nurbs_error3_t : identifier;
pen_glu_nurbs_error4_t : identifier;
pen_glu_nurbs_error5_t : identifier;
pen_glu_nurbs_error6_t : identifier;
pen_glu_nurbs_error7_t : identifier;
pen_glu_nurbs_error8_t : identifier;
pen_glu_nurbs_error9_t : identifier;
pen_glu_nurbs_error10_t : identifier;
pen_glu_nurbs_error11_t : identifier;
pen_glu_nurbs_error12_t : identifier;
pen_glu_nurbs_error13_t : identifier;
pen_glu_nurbs_error14_t : identifier;
pen_glu_nurbs_error15_t : identifier;
pen_glu_nurbs_error16_t : identifier;
pen_glu_nurbs_error17_t : identifier;
pen_glu_nurbs_error18_t : identifier;
pen_glu_nurbs_error19_t : identifier;
pen_glu_nurbs_error20_t : identifier;
pen_glu_nurbs_error21_t : identifier;
pen_glu_nurbs_error22_t : identifier;
pen_glu_nurbs_error23_t : identifier;
pen_glu_nurbs_error24_t : identifier;
pen_glu_nurbs_error25_t : identifier;
pen_glu_nurbs_error26_t : identifier;
pen_glu_nurbs_error27_t : identifier;
pen_glu_nurbs_error28_t : identifier;
pen_glu_nurbs_error29_t : identifier;
pen_glu_nurbs_error30_t : identifier;
pen_glu_nurbs_error31_t : identifier;
pen_glu_nurbs_error32_t : identifier;
pen_glu_nurbs_error33_t : identifier;
pen_glu_nurbs_error34_t : identifier;
pen_glu_nurbs_error35_t : identifier;
pen_glu_nurbs_error36_t : identifier;
pen_glu_nurbs_error37_t : identifier;
pen_glunurbsproperties_t : identifier;
pen_glu_auto_load_matrix_t : identifier;
pen_glu_culling_t : identifier;
pen_glu_sampling_tolerance_t : identifier;
pen_glu_display_mode_t : identifier;
pen_glu_parametric_tolerance_t : identifier;
pen_glu_sampling_method_t : identifier;
pen_glu_u_step_t : identifier;
pen_glu_v_step_t : identifier;
pen_glu_nurbs_mode_t : identifier;
pen_glu_nurbs_mode_ext_t : identifier;
pen_glu_nurbs_tessellator_t : identifier;
pen_glu_nurbs_tessellator_ext_t : identifier;
pen_glu_nurbs_renderer_t : identifier;
pen_glu_nurbs_renderer_ext_t : identifier;
pen_glu_object_parametric_error_t : identifier;
pen_glu_object_parametric_error_ext_t : identifier;
pen_glu_object_path_length_t : identifier;
pen_glu_object_path_length_ext_t : identifier;
pen_glu_path_length_t : identifier;
pen_glu_parametric_error_t : identifier;
pen_glu_domain_distance_t : identifier;
pen_glu_map1_trim_2_t : identifier;
pen_glu_map1_trim_3_t : identifier;
pen_gluquaddrawstyle_t : identifier;
pen_glu_point_t : identifier;
pen_glu_line_t : identifier;
pen_glu_fill_t : identifier;
pen_glu_silhouette_t : identifier;
pen_gluquadricnormal_t : identifier;
pen_glu_smooth_t : identifier;
pen_glu_flat_t : identifier;
pen_glu_none_t : identifier;
pen_gluquadorientation_t : identifier;
pen_glu_outside_t : identifier;
pen_glu_inside_t : identifier;
pen_glutesscallbacks_t : identifier;
pen_glu_tess_begin_t : identifier;
pen_glu_begin_t : identifier;
pen_glu_tess_vertex_t : identifier;
pen_glu_vertex_t : identifier;
pen_glu_tess_end_t : identifier;
pen_glu_end_t : identifier;
pen_glu_tess_error_t : identifier;
pen_glu_tess_edge_flag_t : identifier;
pen_glu_edge_flag_t : identifier;
pen_glu_tess_combine_t : identifier;
pen_glu_tess_begin_data_t : identifier;
pen_glu_tess_vertex_data_t : identifier;
pen_glu_tess_end_data_t : identifier;
pen_glu_tess_error_data_t : identifier;
pen_glu_tess_edge_flag_data_t : identifier;
pen_glu_tess_combine_data_t : identifier;
pen_glutesscontour_t : identifier;
pen_glu_cw_t : identifier;
pen_glu_ccw_t : identifier;
pen_glu_interior_t : identifier;
pen_glu_exterior_t : identifier;
pen_glu_unknown_t : identifier;
pen_glutessproperties_t : identifier;
pen_glu_tess_winding_rule_t : identifier;
pen_glu_tess_boundary_only_t : identifier;
pen_glu_tess_tolerance_t : identifier;
pen_glu_tess_error1_t : identifier;
pen_glu_tess_error2_t : identifier;
pen_glu_tess_error3_t : identifier;
pen_glu_tess_error4_t : identifier;
pen_glu_tess_error5_t : identifier;
pen_glu_tess_error6_t : identifier;
pen_glu_tess_error7_t : identifier;
pen_glu_tess_error8_t : identifier;
pen_glu_tess_missing_begin_polygon_t : identifier;
pen_glu_tess_missing_begin_contour_t : identifier;
pen_glu_tess_missing_end_polygon_t : identifier;
pen_glu_tess_missing_end_contour_t : identifier;
pen_glu_tess_coord_too_large_t : identifier;
pen_glu_tess_need_combine_callback_t : identifier;
pen_glu_tess_winding_odd_t : identifier;
pen_glu_tess_winding_nonzero_t : identifier;
pen_glu_tess_winding_positive_t : identifier;
pen_glu_tess_winding_negative_t : identifier;
pen_glu_tess_winding_abs_geq_two_t : identifier;
pen_glu_tess_max_coord_t : identifier;

-- SparForte additions

pen_raise_gl_errors_t : identifier;
pen_is_raising_gl_errors_t : identifier;

-- OpenGL Functions (MESA library)

pen_glclearindex_t : identifier;
pen_glclearcolor_t : identifier;
pen_glclear_t : identifier;
pen_glindexmask_t : identifier;
pen_glcolormask_t : identifier;
pen_glalphafunc_t : identifier;
pen_glblendfunc_t : identifier;
pen_gllogicop_t : identifier;
pen_glcullface_t : identifier;
pen_glfrontface_t : identifier;
pen_glpointsize_t : identifier;
pen_gllinewidth_t : identifier;
pen_gllinestipple_t : identifier;
pen_glpolygonmode_t : identifier;
pen_glpolygonoffset_t : identifier;
pen_glpolygonstipple_t : identifier;
pen_glgetpolygonstipple_t : identifier;
pen_gledgeflag_t : identifier;
pen_gledgeflagv_t : identifier;
pen_glscissor_t : identifier;
pen_glclipplane_t : identifier;
pen_glgetclipplane_t : identifier;
pen_gldrawbuffer_t : identifier;
pen_glreadbuffer_t : identifier;
pen_glenable_t : identifier;
pen_gldisable_t : identifier;
pen_glisenabled_t : identifier;
pen_glenableclientstate_t : identifier;
pen_gldisableclientstate_t : identifier;
pen_glgetbooleanv_t : identifier;
pen_glgetdoublev_t : identifier;
pen_glgetfloatv_t : identifier;
pen_glgetintegerv_t : identifier;
pen_glpushattrib_t : identifier;
pen_glpopattrib_t : identifier;
pen_glpushclientattrib_t : identifier;
pen_glpopclientattrib_t : identifier;
pen_glrendermode_t : identifier;
pen_glgeterror_t : identifier;
pen_glgetstring_t : identifier;
pen_glfinish_t : identifier;
pen_glflush_t : identifier;
pen_glhint_t : identifier;
pen_glcleardepth_t : identifier;
pen_gldepthfunc_t : identifier;
pen_gldepthmask_t : identifier;
pen_gldepthrange_t : identifier;
pen_glclearaccum_t : identifier;
pen_glaccum_t : identifier;
pen_glmatrixmode_t : identifier;
pen_glortho_t : identifier;
pen_glfrustum_t : identifier;
pen_glviewport_t : identifier;
pen_glpushmatrix_t : identifier;
pen_glpopmatrix_t : identifier;
pen_glloadidentity_t : identifier;
pen_glloadmatrixd_t : identifier;
pen_glloadmatrixf_t : identifier;
pen_glmultmatrixd_t : identifier;
pen_glmultmatrixf_t : identifier;
pen_glrotated_t : identifier;
pen_glrotatef_t : identifier;
pen_glscaled_t : identifier;
pen_glscalef_t : identifier;
pen_gltranslated_t : identifier;
pen_gltranslatef_t : identifier;
pen_glislist_t : identifier;
pen_gldeletelists_t : identifier;
pen_glgenlists_t : identifier;
pen_glnewlist_t : identifier;
pen_glendlist_t : identifier;
pen_glcalllist_t : identifier;
pen_glcalllists_t : identifier;
pen_gllistbase_t : identifier;
pen_glbegin_t : identifier;
pen_glend_t : identifier;
pen_glvertex2d_t : identifier;
pen_glvertex2f_t : identifier;
pen_glvertex2i_t : identifier;
pen_glvertex2s_t : identifier;
pen_glvertex3d_t : identifier;
pen_glvertex3f_t : identifier;
pen_glvertex3i_t : identifier;
pen_glvertex3s_t : identifier;
pen_glvertex4d_t : identifier;
pen_glvertex4f_t : identifier;
pen_glvertex4i_t : identifier;
pen_glvertex4s_t : identifier;
pen_glvertex2dv_t : identifier;
pen_glvertex2fv_t : identifier;
pen_glvertex2iv_t : identifier;
pen_glvertex2sv_t : identifier;
pen_glvertex3dv_t : identifier;
pen_glvertex3fv_t : identifier;
pen_glvertex3iv_t : identifier;
pen_glvertex3sv_t : identifier;
pen_glvertex4dv_t : identifier;
pen_glvertex4fv_t : identifier;
pen_glvertex4iv_t : identifier;
pen_glvertex4sv_t : identifier;
pen_glnormal3b_t : identifier;
pen_glnormal3d_t : identifier;
pen_glnormal3f_t : identifier;
pen_glnormal3i_t : identifier;
pen_glnormal3s_t : identifier;
pen_glnormal3bv_t : identifier;
pen_glnormal3dv_t : identifier;
pen_glnormal3fv_t : identifier;
pen_glnormal3iv_t : identifier;
pen_glnormal3sv_t : identifier;
pen_glindexd_t : identifier;
pen_glindexf_t : identifier;
pen_glindexi_t : identifier;
pen_glindexs_t : identifier;
pen_glindexub_t : identifier;
pen_glindexdv_t : identifier;
pen_glindexfv_t : identifier;
pen_glindexiv_t : identifier;
pen_glindexsv_t : identifier;
pen_glindexubv_t : identifier;
pen_glcolor3_t : identifier;
pen_glcolor3b_t : identifier;
pen_glcolor3d_t : identifier;
pen_glcolor3f_t : identifier;
pen_glcolor3i_t : identifier;
pen_glcolor3s_t : identifier;
pen_glcolor3ub_t : identifier;
pen_glcolor3ui_t : identifier;
pen_glcolor3us_t : identifier;
pen_glcolor4_t : identifier;
pen_glcolor4b_t : identifier;
pen_glcolor4d_t : identifier;
pen_glcolor4f_t : identifier;
pen_glcolor4i_t : identifier;
pen_glcolor4s_t : identifier;
pen_glcolor4ub_t : identifier;
pen_glcolor4ui_t : identifier;
pen_glcolor4us_t : identifier;
pen_glcolor3bv_t : identifier;
pen_glcolor3dv_t : identifier;
pen_glcolor3fv_t : identifier;
pen_glcolor3iv_t : identifier;
pen_glcolor3sv_t : identifier;
pen_glcolor3ubv_t : identifier;
pen_glcolor3uiv_t : identifier;
pen_glcolor3usv_t : identifier;
pen_glcolor4bv_t : identifier;
pen_glcolor4dv_t : identifier;
pen_glcolor4fv_t : identifier;
pen_glcolor4iv_t : identifier;
pen_glcolor4sv_t : identifier;
pen_glcolor4ubv_t : identifier;
pen_glcolor4uiv_t : identifier;
pen_glcolor4usv_t : identifier;
pen_gltexcoord1d_t : identifier;
pen_gltexcoord1f_t : identifier;
pen_gltexcoord1i_t : identifier;
pen_gltexcoord1s_t : identifier;
pen_gltexcoord2d_t : identifier;
pen_gltexcoord2f_t : identifier;
pen_gltexcoord2i_t : identifier;
pen_gltexcoord2s_t : identifier;
pen_gltexcoord3d_t : identifier;
pen_gltexcoord3f_t : identifier;
pen_gltexcoord3i_t : identifier;
pen_gltexcoord3s_t : identifier;
pen_gltexcoord4d_t : identifier;
pen_gltexcoord4f_t : identifier;
pen_gltexcoord4i_t : identifier;
pen_gltexcoord4s_t : identifier;
pen_gltexcoord1dv_t : identifier;
pen_gltexcoord1fv_t : identifier;
pen_gltexcoord1iv_t : identifier;
pen_gltexcoord1sv_t : identifier;
pen_gltexcoord2dv_t : identifier;
pen_gltexcoord2fv_t : identifier;
pen_gltexcoord2iv_t : identifier;
pen_gltexcoord2sv_t : identifier;
pen_gltexcoord3dv_t : identifier;
pen_gltexcoord3fv_t : identifier;
pen_gltexcoord3iv_t : identifier;
pen_gltexcoord3sv_t : identifier;
pen_gltexcoord4dv_t : identifier;
pen_gltexcoord4fv_t : identifier;
pen_gltexcoord4iv_t : identifier;
pen_gltexcoord4sv_t : identifier;
pen_glrasterpos2d_t : identifier;
pen_glrasterpos2f_t : identifier;
pen_glrasterpos2i_t : identifier;
pen_glrasterpos2s_t : identifier;
pen_glrasterpos3d_t : identifier;
pen_glrasterpos3f_t : identifier;
pen_glrasterpos3i_t : identifier;
pen_glrasterpos3s_t : identifier;
pen_glrasterpos4d_t : identifier;
pen_glrasterpos4f_t : identifier;
pen_glrasterpos4i_t : identifier;
pen_glrasterpos4s_t : identifier;
pen_glrasterpos2dv_t : identifier;
pen_glrasterpos2fv_t : identifier;
pen_glrasterpos2iv_t : identifier;
pen_glrasterpos2sv_t : identifier;
pen_glrasterpos3dv_t : identifier;
pen_glrasterpos3fv_t : identifier;
pen_glrasterpos3iv_t : identifier;
pen_glrasterpos3sv_t : identifier;
pen_glrasterpos4dv_t : identifier;
pen_glrasterpos4fv_t : identifier;
pen_glrasterpos4iv_t : identifier;
pen_glrasterpos4sv_t : identifier;
pen_glrectd_t : identifier;
pen_glrectf_t : identifier;
pen_glrecti_t : identifier;
pen_glrects_t : identifier;
pen_glrectdv_t : identifier;
pen_glrectfv_t : identifier;
pen_glrectiv_t : identifier;
pen_glrectsv_t : identifier;
pen_glvertexpointer_t : identifier;
pen_glnormalpointer_t : identifier;
pen_glcolorpointer_t : identifier;
pen_glindexpointer_t : identifier;
pen_gltexcoordpointer_t : identifier;
pen_gledgeflagpointer_t : identifier;
pen_glgetpointerv_t : identifier;
pen_glarrayelement_t : identifier;
pen_gldrawarrays_t : identifier;
pen_gldrawelements_t : identifier;
pen_glinterleavedarrays_t : identifier;
pen_glshademodel_t : identifier;
pen_gllightf_t : identifier;
pen_gllighti_t : identifier;
pen_gllightfv_t : identifier;
pen_gllightiv_t : identifier;
pen_glgetlightfv_t : identifier;
pen_glgetlightiv_t : identifier;
pen_gllightmodelf_t : identifier;
pen_gllightmodeli_t : identifier;
pen_gllightmodelfv_t : identifier;
pen_gllightmodeliv_t : identifier;
pen_glmaterialf_t : identifier;
pen_glmateriali_t : identifier;
pen_glmaterialfv_t : identifier;
pen_glmaterialiv_t : identifier;
pen_glgetmaterialfv_t : identifier;
pen_glgetmaterialiv_t : identifier;
pen_glcolormaterial_t : identifier;
pen_glpixelzoom_t : identifier;
pen_glpixelstoref_t : identifier;
pen_glpixelstorei_t : identifier;
pen_glpixeltransferf_t : identifier;
pen_glpixeltransferi_t : identifier;
pen_glpixelmapfv_t : identifier;
pen_glpixelmapuiv_t : identifier;
pen_glpixelmapusv_t : identifier;
pen_glgetpixelmapfv_t : identifier;
pen_glgetpixelmapuiv_t : identifier;
pen_glgetpixelmapusv_t : identifier;
pen_glbitmap_t : identifier;
pen_glreadpixels_t : identifier;
pen_gldrawpixels_t : identifier;
pen_glcopypixels_t : identifier;
pen_glstencilfunc_t : identifier;
pen_glstencilmask_t : identifier;
pen_glstencilop_t : identifier;
pen_glclearstencil_t : identifier;
pen_gltexgend_t : identifier;
pen_gltexgenf_t : identifier;
pen_gltexgeni_t : identifier;
pen_gltexgendv_t : identifier;
pen_gltexgenfv_t : identifier;
pen_gltexgeniv_t : identifier;
pen_glgettexgendv_t : identifier;
pen_glgettexgenfv_t : identifier;
pen_glgettexgeniv_t : identifier;
pen_gltexenvf_t : identifier;
pen_gltexenvi_t : identifier;
pen_gltexenvfv_t : identifier;
pen_gltexenviv_t : identifier;
pen_glgettexenvfv_t : identifier;
pen_glgettexenviv_t : identifier;
pen_gltexparameterf_t : identifier;
pen_gltexparameteri_t : identifier;
pen_gltexparameterfv_t : identifier;
pen_gltexparameteriv_t : identifier;
pen_glgettexparameterfv_t : identifier;
pen_glgettexparameteriv_t : identifier;
pen_glgettexlevelparameterfv_t : identifier;
pen_glgettexlevelparameteriv_t : identifier;
pen_glteximage1d_t : identifier;
pen_glteximage2d_t : identifier;
pen_glgetteximage_t : identifier;
pen_glgentextures_t : identifier;
pen_gldeletetextures_t : identifier;
pen_glbindtexture_t : identifier;
pen_glprioritizetextures_t : identifier;
pen_glaretexturesresident_t : identifier;
pen_glistexture_t : identifier;
pen_gltexsubimage1d_t : identifier;
pen_gltexsubimage2d_t : identifier;
pen_glcopyteximage1d_t : identifier;
pen_glcopyteximage2d_t : identifier;
pen_glcopytexsubimage1d_t : identifier;
pen_glcopytexsubimage2d_t : identifier;
pen_glmap1d_t : identifier;
pen_glmap1f_t : identifier;
pen_glmap2d_t : identifier;
pen_glmap2f_t : identifier;
pen_glgetmapdv_t : identifier;
pen_glgetmapfv_t : identifier;
pen_glgetmapiv_t : identifier;
pen_glevalcoord1d_t : identifier;
pen_glevalcoord1f_t : identifier;
pen_glevalcoord1dv_t : identifier;
pen_glevalcoord1fv_t : identifier;
pen_glevalcoord2d_t : identifier;
pen_glevalcoord2f_t : identifier;
pen_glevalcoord2dv_t : identifier;
pen_glevalcoord2fv_t : identifier;
pen_glmapgrid1d_t : identifier;
pen_glmapgrid1f_t : identifier;
pen_glmapgrid2d_t : identifier;
pen_glmapgrid2f_t : identifier;
pen_glevalpoint1_t : identifier;
pen_glevalpoint2_t : identifier;
pen_glevalmesh1_t : identifier;
pen_glevalmesh2_t : identifier;
pen_glfogf_t : identifier;
pen_glfogi_t : identifier;
pen_glfogfv_t : identifier;
pen_glfogiv_t : identifier;
pen_glfeedbackbuffer_t : identifier;
pen_glpassthrough_t : identifier;
pen_glselectbuffer_t : identifier;
pen_glinitnames_t : identifier;
pen_glloadname_t : identifier;
pen_glpushname_t : identifier;
pen_glpopname_t : identifier;
pen_gldrawrangeelements_t : identifier;
pen_glteximage3d_t : identifier;
pen_gltexsubimage3d_t : identifier;
pen_glcopytexsubimage3d_t : identifier;
pen_glcolortable_t : identifier;
pen_glcolorsubtable_t : identifier;
pen_glcolortableparameteriv_t : identifier;
pen_glcolortableparameterfv_t : identifier;
pen_glcopycolorsubtable_t : identifier;
pen_glcopycolortable_t : identifier;
pen_glgetcolortable_t : identifier;
pen_glgetcolortableparameterfv_t : identifier;
pen_glgetcolortableparameteriv_t : identifier;
pen_glblendequation_t : identifier;
pen_glblendcolor_t : identifier;
pen_glhistogram_t : identifier;
pen_glresethistogram_t : identifier;
pen_glgethistogram_t : identifier;
pen_glgethistogramparameterfv_t : identifier;
pen_glgethistogramparameteriv_t : identifier;
pen_glminmax_t : identifier;
pen_glresetminmax_t : identifier;
pen_glgetminmax_t : identifier;
pen_glgetminmaxparameterfv_t : identifier;
pen_glgetminmaxparameteriv_t : identifier;
pen_glconvolutionfilter1d_t : identifier;
pen_glconvolutionfilter2d_t : identifier;
pen_glconvolutionparameterf_t : identifier;
pen_glconvolutionparameterfv_t : identifier;
pen_glconvolutionparameterfv2_t : identifier; -- two different return values
pen_glconvolutionparameteri_t : identifier;
pen_glconvolutionparameteriv_t : identifier;
pen_glcopyconvolutionfilter1d_t : identifier;
pen_glcopyconvolutionfilter2d_t : identifier;
pen_glgetconvolutionfilter_t : identifier;
pen_glgetconvolutionparameterfv_t : identifier;
pen_glgetconvolutionparameteriv_t : identifier;
pen_glseparablefilter2d_t : identifier;
pen_glgetseparablefilter_t : identifier;
pen_glactivetexture_t : identifier;
pen_glclientactivetexture_t : identifier;
pen_glcompressedteximage1d_t : identifier;
pen_glcompressedteximage2d_t : identifier;
pen_glcompressedteximage3d_t : identifier;
pen_glcompressedtexsubimage1d_t : identifier;
pen_glcompressedtexsubimage2d_t : identifier;
pen_glcompressedtexsubimage3d_t : identifier;
pen_glgetcompressedteximage_t : identifier;
pen_glmultitexcoord1d_t : identifier;
pen_glmultitexcoord1dv_t : identifier;
pen_glmultitexcoord1f_t : identifier;
pen_glmultitexcoord1fv_t : identifier;
pen_glmultitexcoord1i_t : identifier;
pen_glmultitexcoord1iv_t : identifier;
pen_glmultitexcoord1s_t : identifier;
pen_glmultitexcoord1sv_t : identifier;
pen_glmultitexcoord2d_t : identifier;
pen_glmultitexcoord2dv_t : identifier;
pen_glmultitexcoord2f_t : identifier;
pen_glmultitexcoord2fv_t : identifier;
pen_glmultitexcoord2i_t : identifier;
pen_glmultitexcoord2iv_t : identifier;
pen_glmultitexcoord2s_t : identifier;
pen_glmultitexcoord2sv_t : identifier;
pen_glmultitexcoord3d_t : identifier;
pen_glmultitexcoord3dv_t : identifier;
pen_glmultitexcoord3f_t : identifier;
pen_glmultitexcoord3fv_t : identifier;
pen_glmultitexcoord3i_t : identifier;
pen_glmultitexcoord3iv_t : identifier;
pen_glmultitexcoord3s_t : identifier;
pen_glmultitexcoord3sv_t : identifier;
pen_glmultitexcoord4d_t : identifier;
pen_glmultitexcoord4dv_t : identifier;
pen_glmultitexcoord4f_t : identifier;
pen_glmultitexcoord4fv_t : identifier;
pen_glmultitexcoord4i_t : identifier;
pen_glmultitexcoord4iv_t : identifier;
pen_glmultitexcoord4s_t : identifier;
pen_glmultitexcoord4sv_t : identifier;
pen_glloadtransposematrixd_t : identifier;
pen_glloadtransposematrixf_t : identifier;
pen_glmulttransposematrixd_t : identifier;
pen_glmulttransposematrixf_t : identifier;
pen_glsamplecoverage_t : identifier;
pen_glactivetexturearb_t : identifier;
pen_glclientactivetexturearb_t : identifier;
pen_glmultitexcoord1darb_t : identifier;
pen_glmultitexcoord1dvarb_t : identifier;
pen_glmultitexcoord1farb_t : identifier;
pen_glmultitexcoord1fvarb_t : identifier;
pen_glmultitexcoord1iarb_t : identifier;
pen_glmultitexcoord1ivarb_t : identifier;
pen_glmultitexcoord1sarb_t : identifier;
pen_glmultitexcoord1svarb_t : identifier;
pen_glmultitexcoord2darb_t : identifier;
pen_glmultitexcoord2dvarb_t : identifier;
pen_glmultitexcoord2farb_t : identifier;
pen_glmultitexcoord2fvarb_t : identifier;
pen_glmultitexcoord2iarb_t : identifier;
pen_glmultitexcoord2ivarb_t : identifier;
pen_glmultitexcoord2sarb_t : identifier;
pen_glmultitexcoord2svarb_t : identifier;
pen_glmultitexcoord3darb_t : identifier;
pen_glmultitexcoord3dvarb_t : identifier;
pen_glmultitexcoord3farb_t : identifier;
pen_glmultitexcoord3fvarb_t : identifier;
pen_glmultitexcoord3iarb_t : identifier;
pen_glmultitexcoord3ivarb_t : identifier;
pen_glmultitexcoord3sarb_t : identifier;
pen_glmultitexcoord3svarb_t : identifier;
pen_glmultitexcoord4darb_t : identifier;
pen_glmultitexcoord4dvarb_t : identifier;
pen_glmultitexcoord4farb_t : identifier;
pen_glmultitexcoord4fvarb_t : identifier;
pen_glmultitexcoord4iarb_t : identifier;
pen_glmultitexcoord4ivarb_t : identifier;
pen_glmultitexcoord4sarb_t : identifier;
pen_glmultitexcoord4svarb_t : identifier;
pen_glcreatedebugobjectmesa_t : identifier;
pen_glcleardebuglogmesa_t : identifier;
pen_glgetdebuglogmesa_t : identifier;
pen_glgetdebugloglengthmesa_t : identifier;
pen_glprogramcallbackmesa_t : identifier;
pen_glgetprogramregisterfvmesa_t : identifier;
pen_glframebuffertexturelayerext_t : identifier;
pen_glblendequationseparateati_t : identifier;
pen_gleglimagetargettexture2does_t : identifier;
pen_gleglimagetargetrenderbufferstorageoes_t : identifier;
pen_glubegincurve_t : identifier;
pen_glubeginpolygon_t : identifier;
pen_glubeginsurface_t : identifier;
pen_glubegintrim_t : identifier;
pen_glubuild1dmipmaplevels_t : identifier;
pen_glubuild1dmipmaps_t : identifier;
pen_glubuild2dmipmaplevels_t : identifier;
pen_glubuild2dmipmaps_t : identifier;
pen_glubuild3dmipmaplevels_t : identifier;
pen_glubuild3dmipmaps_t : identifier;
pen_glucheckextension_t : identifier;
pen_glucylinder_t : identifier;
pen_gludeletenurbsrenderer_t : identifier;
pen_gludeletequadric_t : identifier;
pen_gludeletetess_t : identifier;
pen_gludisk_t : identifier;
pen_gluendcurve_t : identifier;
pen_gluendpolygon_t : identifier;
pen_gluendsurface_t : identifier;
pen_gluendtrim_t : identifier;
pen_gluerrorstring_t : identifier;
pen_glugetnurbsproperty_t : identifier;
pen_glugetstring_t : identifier;
pen_glugettessproperty_t : identifier;
pen_gluloadsamplingmatrices_t : identifier;
pen_glulookat_t : identifier;
pen_glunewnurbsrenderer_t : identifier;
pen_glunewquadric_t : identifier;
pen_glunewtess_t : identifier;
pen_glunextcontour_t : identifier;
pen_glunurbscallback_t : identifier;
pen_glunurbscallbackdata_t : identifier;
pen_glunurbscallbackdataext_t : identifier;
pen_glunurbscurve_t : identifier;
pen_glunurbsproperty_t : identifier;
pen_glunurbssurface_t : identifier;
pen_gluortho2d_t : identifier;
pen_glupartialdisk_t : identifier;
pen_gluperspective_t : identifier;
pen_glupickmatrix_t : identifier;
pen_gluproject_t : identifier;
pen_glupwlcurve_t : identifier;
pen_gluquadriccallback_t : identifier;
pen_gluquadricdrawstyle_t : identifier;
pen_gluquadricnormals_t : identifier;
pen_gluquadricorientation_t : identifier;
pen_gluquadrictexture_t : identifier;
pen_gluscaleimage_t : identifier;
pen_glusphere_t : identifier;
pen_glutessbegincontour_t : identifier;
pen_glutessbeginpolygon_t : identifier;
pen_glutesscallback_t : identifier;
pen_glutessendcontour_t : identifier;
pen_glutessendpolygon_t : identifier;
pen_glutessnormal_t : identifier;
pen_glutessproperty_t : identifier;
pen_glutessvertex_t : identifier;
pen_gluunproject_t : identifier;
pen_gluunproject4_t : identifier;

-- C resources

pen_gl_byte_array_t: identifier;
pen_new_gl_byte_array_t : identifier;
pen_set_gl_byte_array_t: identifier;

pen_gl_short_array_t: identifier;
pen_new_gl_short_array_t : identifier;
pen_set_gl_short_array_t: identifier;

pen_gl_int_array_t: identifier;
pen_new_gl_int_array_t : identifier;
pen_set_gl_int_array_t: identifier;

pen_gl_float_array_t: identifier;
pen_new_gl_float_array_t : identifier;
pen_set_gl_float_array_t: identifier;

pen_gl_double_array_t: identifier;
pen_new_gl_double_array_t : identifier;
pen_set_gl_double_array_t: identifier;

------------------------------------------------------------------------------
-- HOUSEKEEPING
------------------------------------------------------------------------------

procedure StartupPen;
procedure ShutdownPen;

------------------------------------------------------------------------------
-- PARSE THE PEN PACKAGE
------------------------------------------------------------------------------

----> Rects

procedure ParsePenSetRect;
procedure ParsePenIsEmptyRect( result : out unbounded_string; kind : out identifier );
procedure ParsePenOffsetRect;
procedure ParsePenInsetRect;
procedure ParsePenIntersectRect;
procedure ParsePenInsideRect( result : out unbounded_string; kind : out identifier );
procedure ParsePenInRect( result : out unbounded_string; kind : out identifier );

procedure ParsePenSetPenMode;
procedure ParsePenSetPenBrush;
procedure ParsePenSetPenInk;
procedure ParsePenSetPenPattern;
procedure ParsePenGetPenMode( result : out unbounded_string; kind : out identifier );
procedure ParsePenGetPenInk;
procedure ParsePenGetPenBrush( result : out unbounded_string; kind : out identifier );
-- procedure ParsePenGetPenPattern( result : out unbounded_string );

procedure ParsePenMoveTo;
procedure ParsePenMove;
procedure ParsePenLineTo;
procedure ParsePenLine;
procedure ParsePenHLine;
procedure ParsePenVLine;

procedure ParsePenFrameRect;
procedure ParsePenPaintRect;
procedure ParsePenFillRect;
procedure ParsePenFrameEllipse;
procedure ParsePenPaintEllipse;
procedure ParsePenFillEllipse;
procedure ParsePenClear;

procedure ParsePenNewScreenCanvas;
procedure ParsePenNewGLScreenCanvas;
procedure ParsePenNewWindowCanvas;
procedure ParsePenNewGLWindowCanvas;
procedure ParsePenNewCanvas;
procedure ParsePenSaveCanvas;
procedure ParsePenSetTitle;
procedure ParsePenCloseCanvas;

procedure ParsePenWaitToReveal;
procedure ParsePenReveal;
procedure ParsePenRevealNow;

procedure ParsePenGreyscale( result : out unbounded_string; kind : out identifier );
procedure ParsePenBlend;
procedure ParsePenFade;

procedure ParsePenSetFont;
procedure ParsePenPut;

procedure ParsePenPlot;

-- OpenGL (Mesa)
-- TODO: these don't need to appear here anymore due to callbacks

--procedure ParsePenglLoadIdentity;
--procedure ParsePenglMatrixMode;
--procedure ParsePenglShadeModel;
-- ParsePenglClearColor
-- ParsePenglClearDepth
-- ParsePenglEnable
-- ParsePenglDisable
-- ParsePenglIsEnabled
-- ParsePenglDepthFunc
-- ParsePenglHint
-- ParsePenglClear

-- ParsePenglViewport
-- ParsePengluPerspective
-- ParsePenglBegin
-- ParsePenglEnd
-- ParsePenglVertex2d
-- ParsePenglVertex2f
-- ParsePenglVertex2i
-- ParsePenglVertex2s
-- ParsePenglVertex3d
-- ParsePenglVertex3f
-- ParsePenglVertex3i
-- ParsePenglVertex3s
-- ParsePenglVertex4d
-- ParsePenglVertex4f
-- ParsePenglVertex4i
-- ParsePenglVertex4s
-- ParsePenglTranslated

-- ParsePenglFlush
-- ParsePenglFinish
-- ParsePenglRotated
-- pen.glcolor3b
-- pen.glcolor3d
-- pen.glcolor3f
-- pen.glcolor3i
-- pen.glcolor3s
-- pen.glcolor3ub
-- pen.glcolor3ui
-- pen.glcolor3us
-- pen.glcolor4b
-- pen.glcolor4d
-- pen.glcolor4f
-- pen.glcolor4i
-- pen.glcolor4s
-- pen.glcolor4ub
-- pen.glcolor4ui
-- pen.glcolor4us
-- pen.glblendfunc
-- pen.glpushmatrix
-- pen.glpopmatrix
-- pen.gltranslatef
-- pen.glrotatef
-- pen.glgeterror
-- pen.glortho
-- pen.glrasterpos2d
-- pen.glrasterpos2f
-- pen.glrasterpos2i
-- pen.glrasterpos2s
-- pen.glrasterpos3d
-- pen.glrasterpos3f
-- pen.glrasterpos3i
-- pen.glrasterpos3s
-- pen.glrasterpos4d
-- pen.glrasterpos4f
-- pen.glrasterpos4i
-- pen.glrasterpos4s
-- pen.glcolor3
-- pen.glcolor4

-- TODO: raise exception

end parser_pen;
